### (c) TIG 2009
### 
### 2D Adjust Tool
### This Tool Adjusts the length of eligible picked Lines by Trimming or 
### Extending them to a pre-selected set of Target-Lines.
### Run it from the menu or toolbar.
### You first Select the Target-Lines by picking them individually or 
### by holding down the mouse-button and dragging over several Lines 
### [like using the Eraser Tool].
### To Remove a Line from the Target-Lines Selection-set press <Shift> 
### and re-pick Target-Lines to be Removed from the Selection-set 
### [the VCB line prompt also changes from 'Adding' to 'Removing'], 
### to toggle between them press <Shift> again.
### Target-Lines forming part of an Arc/Polygon/Curve etc as a Segment 
### are Selected individually...
### Target-Lines CANNOT included Construction-Lines [aka Guide-Lines].
### Tip: Draw a small piece of temporary Line over the Cline to give a 
### potential Intersection 'Line'.
### It's recommended that you don't have too many Target-Lines in any 
### set - otherwise the resultant Adjustments might be unexpected - 
### especially where Curve/Arc Lines are picked as each Segment becomes 
### a Target-Line: instead Select a modest number, Adjust some Lines, 
### then double-click to Select new Target-Lines as needed etc...
### As you Select them the Target-Lines are highlighted 'orange' for 
### clarity.  During this stage the cursor is similarly colored.
### When all of the required Target-Lines are Selected press <Enter>, or
### double-click the mouse-button.  The Target-Lines remain highlighted, 
### but their color is changed to be 'cyan' - the cursor color and 
### VCB messages also change to suit.
### Now you Pick the Lines you want to 'Adjust'.
### Line will 'Adjust' and either Trim or Extend to the nearest 
### Target-Line – if any.
### To Adjust again up to another Target-Line re-pick the Line.
### In a similar way to the initial Target-Lines Selection methods you 
### can also Adjust several Lines at once by holding down the 
### mouse-button and dragging over them.  However, note that slowly 
### dragging might result in a Line first Extending then Trimming !   
### Use with care...
### You can 'undo' the last Adjustment by pressing <Esc>...
### The picked Line Adjusts to the Target-Lines' 'projected extension'.
### Lines without connected geometry at their End to be Adjusted have 
### that End Vertex moved to suit [Trim or Extend]: however, Lines with 
### 'Shared Vertices' or Faces are not changed - but a new piece of 
### Line will be added from that End Vertex to the Adjusted location.
### Lines Adjusted to a Selected Target Arc change to an Intersection 
### with the appropriate Arc's Segment.
### Tip: If you want a 'True Intersections' between an Arc Circumference 
### and a Line etc, then it's recommended that you use one of TIG's 
### other Tools - like TrueTangents and TrueIntersections...
### If the Line picked for Adjustment is part of an Arc then the 
### picked portion may be Trimmed back to suit.
### If that Arc would require Extension and it is tied to other Geometry 
### then there is a beep - the Console suggests you draw a new 3-point 
### Circle through Arc's Vertices and then Erase unwanted parts...
### That Arc is not readily Extendable because its Number of Segments or 
### End Segment's lengths can be unmatchable to another Arc/Circle 
### that would be required to replace it - thus messing up connected 
### Geometry etc...  However, 'Lone' Arcs can be Extended to suitable 
### Target-Lines: pick one of the Arc's End Segment to be Extended.  
### If the Arc touches/straddles the Target-Line at an End then picking 
### the Arc on any Segment other than the unconnected End one will Trim 
### the Arc back to the Target-Line, rather than Extend it.  
### Sometimes you might extend an Arc in error - it can then be 
### Trimmed back to the Line by picking it again.
### This 'Lone' Arc Extension redraws the Arc and gives it a Number 
### of Segments equivalent to the original increased pro rata to suit 
### the enlarged swept-angle.
### If the Line picked for Adjustment is part of a Circle or Polygon 
### then the picked portion will be Trimmed back to the Target-Line 
### - note because they 'Loop' you cannot 'Extend' these.
### If a picked Line is also in the Target-Lines set then it will still 
### be Adjusted to suit, and the highlighted Target-Line set is changed 
### to match.  If the Adjustment involves a 'Trim' that removes 
### complete Lines that were previously Target-Lines - e.g. parts of a 
### Polygon are gone or a Line is trimmed back twice until it has a 
### zero length - then those Target-Lines are removed from the 
### Target-Line set.  If the Target-Lines set is 'emptied' by this then 
### the Tool is reset: you will be prompted to pick more Target-Lines...
### Any Picked Lines that do not intersect with the Target-Lines set 
### are ignored.
### Occasionally bits of Line might get split at the Target-Line but 
### refuse to be Erased by further Trimming - however, they can still 
### be Erased with the normal Eraser Tool later...
### To end the current Adjustment session press <Enter> or double-click 
### the mouse-button - you can then start another Target-Lines set.
### To exit the Tool completely either press <Enter> or double-click 
### the mouse-button twice/three times depending on the stage you are 
### at, or just select any other Tool.
###
### v3.0 First issue of Adjust Tool. 20091002
### v3.4 Vertex move for lone Lines improved.  Lone Arc Extend fixed. 20091010
### v3.5 Adjust to Arcs changed to individual segments. 20091014
### v4.0 DeBabelized. 20091122
### v4.2 \n changed to avoid db clash 20091125
### v4.3 db arguments parenthesized (). 20100927
###
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------

class AdjustTool2D

def db(string)
  dir=File.dirname(__FILE__) ### adjust folder to suit tool
  toolname="2Dtools"  ### adjust xxx to suit tool...
  locale=Sketchup.get_locale.upcase
  path=dir+"/"+toolname+locale+".lingvo"
  if not File.exist?(path)
     return string
  else
    deBabelizer(string,path)
  end 
end#def

def getExtents
    bbox=Sketchup.active_model.bounds
    bbox.add(@ip.position)if @ip and @ip.valid?
    bbox.add(@ip1.position)if @ip1 and @ip1.valid?
    bbox.add(@ip2.position)if @ip2 and @ip2.valid?
    bbox.add(@ip3.position)if @ip3 and @ip3.valid?
    return bbox
end

def initialize
    @ip1 = nil
    @ip = nil
    @xdown = 0
    @ydown = 0
    @state=0
end

def activate
    @cursor0=nil
    curpath0=File.dirname(__FILE__)+"/Icons/2Dadjust_cursor0.png"
    @cursor0=UI::create_cursor(curpath0,0,24)if curpath0
    @cursor1=nil
    curpath1=File.dirname(__FILE__)+"/Icons/2Dadjust_cursor1.png"
    @cursor1=UI::create_cursor(curpath1,0,24)if curpath1
    ### get/set reference plane 'z'
    @z=Sketchup.active_model.get_attribute("2Dtools","z",nil)
    Sketchup.active_model.set_attribute("2Dtools","z",0.0.mm)if not @z
    @z=Sketchup.active_model.get_attribute("2Dtools","z",nil)
    ###
    @ip1 = Sketchup::InputPoint.new
    @ip = Sketchup::InputPoint.new
    @drawn = false
    Sketchup.active_model.selection.clear
    @state=0
    self.reset(nil)
    ###
end


def deactivate(view)
    Sketchup::set_status_text("",SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
    Sketchup::set_status_text("",SB_VCB_VALUE)
    view.invalidate if view
end

def reset(view)
    @state=0
    @edge=nil
    @targets=[]
    @ip.clear
    @ip1.clear
    if view
      view.model.selection.clear
      view.tooltip = nil
      view.invalidate if @drawn
    end
    @edge=nil
    @drawn=false
    @click=false
    @dragging=false ### MOUSE DOWN
    @dragging_msg=db(", Drag for Multiples... ")
    @remove=false
    @remove_msg=db(" Adding: <Shift>=Remove ")
    Sketchup::set_status_text((db("2D Adjust: Select Target Lines... "))+@dragging_msg+(db(" - Double-Click/<Enter> to Adjust Lines")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
end

def onReturn(view)
  view.invalidate
  case @state
   when 0
    if not @targets[0]
      view.invalidate
      Sketchup::set_status_text("",SB_PROMPT)
      Sketchup.send_action("selectSelectionTool:")
    end#if
    self.onSetCursor
    Sketchup::set_status_text((db("2D Adjust: Select Lines to Adjust"))+@dragging_msg+(db(" - Double-Click/<Enter> to Select New Target Lines...")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
    @state=1
   when 1
     self.reset(view)
  end#case
end

def onSetCursor()
    if @state==0
      UI::set_cursor(@cursor0)if @cursor0
    else
      UI::set_cursor(@cursor1)if @cursor1
    end#if
end

def onMouseMove(flags, x, y, view)
  case @state
   when 0
    Sketchup::set_status_text((db("2D Adjust: Select Target Lines... "))+@dragging_msg+@remove_msg+(db" - Double-Click/<Enter> to Adjust Lines"), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
    @ip.pick view, x, y
    if @ip != @ip1
        view.invalidate if @ip.display? or @ip1.display?
        @ip1.copy! @ip
        view.tooltip = db("Target-Line")#@ip1.tooltip
    end
    # Check if the mouse was moved far enough to find another line.
    # This is used so that you can pick lines by dragging
    if @click and (x-@xdown).abs > 10 || (y-@ydown).abs > 10
        @dragging=true
        @dragging_msg=db("- Select Lines by Dragging Cursor over them...")
    end
    if @click and @dragging
        @edge=self.edge_below_mouse_drag(view,x,y)
        self.target_lines(view)if @edge
    end#if
   when 1
    Sketchup::set_status_text((db("2D Adjust: Select Lines to Adjust"))+@dragging_msg+(db(" - Double-Click/<Enter> to Select New Target Lines...")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
    @ip.pick view, x, y
    if @ip != @ip1
        view.invalidate if @ip.display? or @ip1.display?
        @ip1.copy! @ip
        view.tooltip = db("Line to Adjust")#@ip1.tooltip
    end
    # Check if the mouse was moved far enough to find another line.
    # This is used so that you can pick lines by dragging
    if @click and (x-@xdown).abs > 10 || (y-@ydown).abs > 10
        @dragging=true
        @dragging_msg=db("- Select Lines by Dragging Cursor over them...")
    end
    if @click and @dragging
        @edge=self.edge_below_mouse_drag(view,x,y)
        self.adjust_line(view)if @edge
    end#if
  end#case
end

def onLButtonDown(flags, x, y, view)
  case @state
   when 0
    @click=true
    @ip1.pick view, x, y
    if @ip1.valid?
        p1=@ip1.position;p1.z=@z
        Sketchup::set_status_text((db("2D Adjust: Select Target Lines... "))+@dragging_msg+@remove_msg+(db(" - Double-Click/<Enter> to Adjust Lines")), SB_PROMPT)
        Sketchup::set_status_text("",SB_VCB_LABEL)
        @xdown = x
        @ydown = y
    end
    ### check if extg edge
    ph=view.pick_helper
    ph.do_pick(x,y)
    picked_edge=ph.picked_edge
    ###@edge=nil
    @edge=picked_edge if picked_edge
    ###
    self.target_lines(view) if @edge
    ###
   when 1
    @click=true
    @ip1.pick view, x, y
    if @ip1.valid?
        p1=@ip1.position;p1.z=@z
        Sketchup::set_status_text((db("2D Adjust: Select Lines to Adjust"))+@dragging_msg+(db(" - Double-Click/<Enter> to Select New Target Lines...")), SB_PROMPT)
        Sketchup::set_status_text("",SB_VCB_LABEL)
        @xdown = x
        @ydown = y
    end
    ### check if extg edge
    ph=view.pick_helper
    ph.do_pick(x,y)
    picked_edge=ph.picked_edge
    ###@edge=nil
    @edge=picked_edge if picked_edge
    ###
    self.adjust_line(view)if @edge
  end#case
end

def onLButtonUp(flags, x, y, view)
     # If we are doing a drag, then ? ...
    view.lock_inference
    @dragging=false
    @click=false
    @dragging_msg=db(", Drag for Multiples... ")
    if @remove
        @remove_msg=db(" Removing: <Shift>=Add ")
    else
        @remove_msg=db(" Adding: <Shift>=Remove ")
    end#if
    ### check if any targets left
    still_targets=false
    @targets.each{|e|(still_targets=true; break)if e.valid?}
    self.reset(view)if not still_targets
end

def onLButtonDoubleClick(flags, x, y, view)
      view.invalidate
  case @state
   when 0
    if not @targets[0]
      view.invalidate
      Sketchup::set_status_text("",SB_PROMPT)
      Sketchup.send_action("selectSelectionTool:")
    end#if
    self.onSetCursor
    Sketchup::set_status_text((db("2D Adjust: Select Lines to Adjust"))+@dragging_msg+(db(" - Double-Click/<Enter> to Select New Target Lines...")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
    @state=1
   when 1
     self.reset(view)
  end#case
end

def onKeyDown(key, repeat, flags, view)
    if @state==0 and key==VK_SHIFT  ### SHIFT = Toggles Add/remove
      if @remove
        @remove=false; @remove_msg=db(" Adding: <Shift>=Remove ")
      else
        @remove=true; @remove_msg=db(" Removing: <Shift>=Add ")
      end#if
      Sketchup::set_status_text((db("2D Adjust: Select Target Lines... "))+@dragging_msg+@remove_msg+(db(" - Double-Click/<Enter> to Adjust Lines")), SB_PROMPT)
    end#if
end

def resume(view)
  view.invalidate
  case @state
   when 0
    Sketchup::set_status_text((db("2D Adjust: Select Target Lines... "))+@dragging_msg+@remove_msg+(db(" - Double-Click/<Enter> to Adjust Lines")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
   when 1
    Sketchup::set_status_text((db("2D Adjust: Select Lines to Adjust"))+@dragging_msg+(db(" - Double-Click/<Enter> to Select New Target Lines...")), SB_PROMPT)
    Sketchup::set_status_text("",SB_VCB_LABEL)
  end#case
end

def draw(view)
    view.line_width=6
    if @state==0
      view.drawing_color="orangered"
    else
      view.drawing_color="cyan"
    end#if
    @targets.each{|e|view.draw_line(e.start.position,e.end.position)if e.valid?}
end

def edge_below_mouse_drag(view, x, y)
    ph=view.pick_helper
    ph.do_pick(x, y, 10)
	ent=ph.best_picked
	if ent and ent.class==Sketchup::Edge
	    @ip.pick view, x, y
	    return ent
	else
		return nil
	end#if
end

def target_lines(view)
  if @remove
    @targets=@targets-[@edge]
  else
    @targets<<@edge
  end#if
=begin
  ### extras if not a 'vanilla edge'
  if @edge.curve
    if @remove
      @edge.curve.edges.each{|e|@targets=@targets-[e]}
    else
      @edge.curve.edges.each{|e|@targets<<e}
    end#if
  end#if
=end
end#def

def adjust_line(view)
  model=view.model
 model.start_operation(db("Adjust Line"))
  if @edge.valid?
    ents=@edge.parent.entities
  else
    return nil
  end#if
  pt=@ip1.position
  p0=@edge.vertices[0].position;p1=@edge.vertices[1].position
  nearpt=p0;nearpt=p1 if pt.distance(p0)>=pt.distance(p1)
  if not @edge.curve ### ==vanilla edge
    int=self.get_intersection(view)
    if int
      if @edge.faces[0]
        edge=ents.add_line(nearpt,int)##############
        lay=@edge.layer if edge
        mat=@edge.material if edge
        edge.layer=lay if lay
        edge.material=mat if mat
        if @targets.include?(@edge)
          @targets<<edge if edge
        end#if
      else ### lone line
        nearvert=@edge.vertices[0]
        nearvert=@edge.vertices[1]if p0.distance(pt)>p1.distance(pt)
        farvert=@edge.other_vertex(nearvert)
        nearpoint=nearvert.position
        farpoint=farvert.position
        farvert_target=false
        farvert.edges.each{|e|
          if @targets.include?(e) and e!=@edge
            farvert_target=true
            break
          end#if
        }
        if nearpoint==int and farvert_target
          @edge.erase!
          @targets=@targets-[@edge]
        elsif farpoint==int
          @edge.erase!
          @targets=@targets-[@edge]
        else
          @edge.erase!#v3.4 <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          @targets=@targets-[@edge]#v3.4 <<<<<<<<<<<<<<<<<<<<<<<<<<<<
          edge=ents.add_line(farpoint,int)############
          edge.layer=lay if lay
          edge.material=mat if mat
          if @targets.include?(@edge)
            @targets<<edge if edge
          end#if
        end#if
      end#if
    end#if
  else ### part of a Curve
    if not @edge.curve.class==Sketchup::ArcCurve
      puts db("It's a 'Curve'.")
      int=self.get_intersection(view)
     if int and not @edge.faces[0]
        nearvert=@edge.vertices[0]
        nearvert=@edge.vertices[1]if p0.distance(pt)>p1.distance(pt)
        farvert=@edge.other_vertex(nearvert)
        nearpoint=nearvert.position
        farpoint=farvert.position
        farvert_target=false
        farvert.edges.each{|e|
          if @targets.include?(e) and e!=@edge
            farvert_target=true
            break
          end#if
        }
        connected=0
        nearvert.edges.each{|e|connected+=1 if e.curve==@edge.curve}
        if nearpoint==int and farvert_target ### one edge curve !
          @edge.erase!
          @targets=@targets-[@edge]
        elsif connected != 2
          pts=[]
          @edge.curve.vertices.each{|v|pts<<v.position.to_a}
          ct=0;pts.each{|p|
            if p==nearpoint.to_a
              pts[ct]=int
            end#if
            ct+=1
          }
          lay=@edge.layer; mat=@edge.material
          @edge.curve.edges.each{|e|e.erase! if e.valid?}
          curve=ents.add_curve(pts)
          curve.each{|e|e.layer=lay;e.material=mat}
          if @targets.include?(@edge)
            @targets=@targets-[@edge]
            @targets<<curve
            @targets.flatten!.uniq!
          end#if
        else ### mid vertex so add new line...
          edge=ents.add_line(nearpt,int)
          lay=@edge.layer if edge
          mat=@edge.material if edge
          edge.layer=lay if lay
          edge.material=mat if mat
          if @targets.include?(@edge)
            @targets<<edge if edge
          end#if
        end#if
      elsif int and @edge.faces[0]
        edge=ents.add_line(nearpt,int)
        lay=@edge.layer if edge
        mat=@edge.material if edge
        edge.layer=lay if lay
        edge.material=mat if mat
        if @targets.include?(@edge)
          @targets<<edge if edge
        end#if
      end#if
    else ### == Arc / Circle / Polygon
      puts db("It's an ArcCurve...")
      int_edge_s=self.test_intersections(view)
      if not int_edge_s
        puts db("No Intersecting Target Line.")
        return nil
      end#if
      arc=@edge.curve
      an_arc=false
      edgecount=0
      arc.edges.each{|e|edgecount=0
        e.vertices.each{|v|
          v.edges.each{|ee|edgecount+=1 if ee.curve==arc}
        }
        if edgecount<4
          an_arc=true; break
        end#if
      }
      if not an_arc and not @edge.faces[0]
        ### it's  NOT an Arc but == Circle OR Polygon OR it has face(s)
        if self.is_polygon?(arc) ### it's a polygon
          puts db("and it's a Polygon.")
          is_poly=true
        else ### it's a circle - make new arc bit...
          puts db("and it's a Circle.")
          is_poly=false
        end#if 'is_poly' no longer used ???
        ### this 'test' makes these into 'split into 2 parts' so treat as 'arc'...
        arc=@edge.curve
        arc.edges.each{|e|e.erase! if e.valid?}
        ###
      elsif an_arc ### it's an Arc !
        puts db("and it's an Arc.")
        if not @edge.faces[0]
          int_edge_s=test_intersections(view)
          int_edge=nil
          ents.each{|e|int_edge=e if e.class==Sketchup::Edge and e.to_s==int_edge_s}
          ### we know arc should/could intersect target already int_edge.
          ### either 0, 1 or 2 edges of Arc might intersect target...
          ### if 0, extend the arc to the target using pickpoint
          ### if 1, extend from picked end to target OR if target is near picked end erase whole arc
          ### if 2, erase part of arc back to target on picked side using pickpoint
          ### int_edge is intersecting edge with picked edge in arc
          poss_ints=[]### possible intersection points of arc's edges and int_edge
          @edge.curve.edges.each{|e|
            poss_ints<<Geom.intersect_line_line([e.start.position,e.end.position],[int_edge.start.position,int_edge.end.position])
          }
          actual_ints=[]### actual intersections in poss_ints
          poss_ints.each{|p|
            @edge.curve.edges.each{|e|
              actual_ints<<p if p.is_between_points?(e.start.position,e.end.position)
            }if p
          }if poss_ints[0]
          ### we can have 0, 1 or 2 actual points
          arcedges=@edge.curve.edges
          tlines=[]
          actual_ints.each{|p|
            tline=ents.add_line(p,[p.x,p.y,p.z+0.4.mm])
            tlines<<tline
          }
          ### tlines will split the Arc
          arc=@edge.curve
          ### see if broken in bits
          if arcedges != @edge.curve.edges and (@edge != arc.first_edge and @edge != arc.last_edge)
            puts db("Arc broken by Line.")
            puts db("... and Partially Erased...")
            arc.edges.each{|e|e.erase! if e.valid?}if arc.valid?
            arc.edges.each{|e|@targets=@targets-[e]}if arc.valid? and @targets.include?(@edge)
            tlines.each{|e|e.erase! if e.valid? and not e.faces[0]}###tidy up
          else
            ###puts "Arc intact."
            ### find 'loose ends' as might be 'on' int_edge
            loose_ends=[]
            arc.vertices.each{|v|edgct=0
              v.edges.each{|ee|edgct+=1 if ee.curve==arc}
              loose_ends << v.position.to_a if edgct <2
            }
            loose_ends.uniq!
            int_edge=nil
            ents.each{|e|int_edge=e if e.class==Sketchup::Edge and e.to_s==int_edge_s}
            eends=[@edge.start.position,@edge.end.position]
            if loose_ends[1]and loose_ends[0].on_line?([int_edge.start.position,int_edge.end.position]) and loose_ends[1].on_line?([int_edge.start.position,int_edge.end.position])
              puts db("Arc Intersects Target-Line Twice - Erased.")
              arc.edges.each{|e|e.erase! if e.valid?}
              arc.edges.each{|e|@targets=@targets-[e]}if @edge.valid? and @targets.include?(@edge)
            elsif loose_ends[1]and loose_ends[0].on_line?([int_edge.start.position,int_edge.end.position]) and not eends.include?(loose_ends[1])
            ###v3.4
              puts db("Arc Intersects Target-Line Once - Erased [Segment Picked was NOT Extentable]*")
              arc.edges.each{|e|e.erase! if e.valid?}if arc.valid?
              arc.edges.each{|e|@targets=@targets-[e]}if arc.valid? and @targets.include?(@edge)
            elsif loose_ends[1]and loose_ends[1].on_line?([int_edge.start.position,int_edge.end.position]) and not eends.include?(loose_ends[0])
            ###v3.4
              puts db("Arc Intersects Target-Line Once - Erased [Segment Picked was Not Extendable]*")
              arc.edges.each{|e|e.erase! if e.valid?}if arc.valid?
              arc.edges.each{|e|@targets=@targets-[e]}if arc.valid? and @targets.include?(@edge)
            else ### can extend ???###v3.4 as either it doesn't touch target-line OR if one end does the picked segment is extenable...
              connected=false
              if @edge.start!=arc.vertices.first and @edge.start!=arc.vertices.last and@edge.end!=arc.vertices.first and @edge.end!=arc.vertices.last
                #connected=true ##################
                #### omit thi stest for now...
              end#if
              ##################
              if connected ### to other geometry BUT not target-line
                UI.beep
                puts db("A 'Connected' Arc Segment cannot be Extended.")
                puts db("Tip: Draw a 3-point Circle through the Arc")
                puts db("and Erase unwanted parts...")
              else ### it's a lone edge - try to extend
                ### get arc info ready to make new arc
                center=arc.center
                xaxis=arc.xaxis
                normal=arc.normal
                radius=arc.radius
                sang=arc.start_angle
                 eang=arc.end_angle
                sango=sang
                eango=eang
                segs=arc.count_edges
                firstedge=arc.first_edge
                lastedge=arc.last_edge
                firstvert=firstedge.start
                firstvert=firstedge.end if firstvert.edges[1]
                lastvert=lastedge.start
                lastvert=lastedge.end if lastvert.edges[1]
                extdvert=firstvert if firstvert.edges.include?(@edge)
                extdvert=lastvert if lastvert.edges.include?(@edge)
                ### int: intersecting point at 90degrees
                intp=center.project_to_line([int_edge.start.position,int_edge.end.position])
                adj=intp.distance(center)
                ang=Math::acos(adj/radius)
                if normal.z>=0
                  ang= -ang if (sango+eango).abs >=180.degrees ###
                else
                  ang= -ang
                  ang= -ang if (sango+eango).abs >=180.degrees ###
                end#if
                if extdvert==firstvert #############################
                  ang= -ang
                end#if
                endp=center.offset((intp-center),radius)
                tr=Geom::Transformation.rotation(center,normal,ang)
                endp.transform!(tr)
                if extdvert==firstvert
                  #puts "first v"
                  if sango+eango<=180.degrees
                    if normal.z>=0
                       sang=xaxis.angle_between(endp-center)*-1
                    else
                       sang=xaxis.angle_between(endp-center)*-1
                    end#if
                  else
                    #puts ">>>"
                    if normal.z>=0
                       sang=xaxis.angle_between(endp-center)*-1
                    else
                       sang=xaxis.angle_between(endp-center)*1
                    end#if
                  end#if
                else
                  #puts "last v"
                  if sango+eango<=180.degrees
                    if normal.z>=0
                       eang=xaxis.angle_between(endp-center)
                    else
                       eang=360.degrees-xaxis.angle_between(endp-center)
                    end#if
                  else
                    if normal.z>=0
                      #puts ">>>"
                       eang=360.degrees-xaxis.angle_between(endp-center)
                    else
                      #puts ">>>"
                       eang=-360.degrees+xaxis.angle_between(endp-center)
                    end#if
                  end#if                 
                end#if
                ###
                arc.edges.each{|e|e.erase! if e.valid?}
                segs=(segs*(360.degrees)/(eango-sango)).ceil
                ents.add_arc(center,xaxis,normal,radius,sang,eang,segs)
                puts db("Arc Extended.")
                ###
              end#if
            end#if
          end#if
        else ### has faces so treat it differently !!!
          UI.beep
          puts db("Arc is Faced, and cannot be trimmed,")
          puts db("also an Attached Arc cannot be extended.")
          puts db("Tip: Draw a 3-point Circle through the Arc")
          puts db("and Erase unwanted parts...")
          ###
        end#if        
      end#if
    end#if
  end#if
 model.commit_operation
end#def adjust_line

def get_intersection(view)
  pt=@ip1.position
  p0=@edge.vertices[0].position;p1=@edge.vertices[1].position
  nearpt=p0;nearpt=p1 if pt.distance(p0)>=pt.distance(p1)
  farpt=p1;farpt=p0 if pt.distance(p1)>pt.distance(p0)
  ints=[]
  @targets.each{|e|
    if e.valid? and int=Geom::intersect_line_line(@edge.line,e.line)
      ints<<[int.distance(nearpt),int.to_a] if int
    end#if
  }
  ints.sort! ### shortest distance first...
  return nil if not ints[0]
  if ints[1] and ints[0][1].distance(nearpt)==0 ### at least two intersections
    return ints[1][1]### nearest intersection to picked point on edge that's > 0
  else
    return ints[0][1]### nearest intersection to picked point on edge even if ==0
  end#if
end#get_int

def test_intersections(view)
  arc=@edge.curve
  center=arc.center
  radius=arc.radius
  ints=[]
  @targets.each{|e|
    if e.valid?
      int=center.project_to_line(e.line)
      ints<<[int.distance(center),int.to_a,e.to_s]if int.distance(center)<radius
    end#if
  }
  ints.sort! ### shortest distance first...
  return nil if not ints[0]
  return ints[0][2]### nearest intersecting edge to picked point on edge even if ==0
end#get_arc_int

def is_polygon?(curve)
    curve.edges.each{|e|
      e.vertices.each{|v|
        if not v.edges[1]
          return false ### it's an arc
          break
        end#if
      }
    }
    ### if we get here it might be a polygon !!!
    model=Sketchup.active_model
    entities=model.active_entities
    edge=curve.edges[0]
    all_connected=edge.all_connected
    tgroup=entities.add_group(all_connected)
    es=edge.start.position
    ee=edge.end.position
    group=tgroup.copy
    tgroup.explode
    gents=group.entities
    gedges=[]
    gents.each{|e|gedges<<e if e.class==Sketchup::Edge}
    gedge=nil
    gedges.each{|e|
      e.smooth=false
      e.soft=false
      gedge=e if (e.start.position==es and e.end.position==ee)or(e.start.position==ee and e.end.position==es)}
    ### remove all faces so only face and pushpull's remain
    gents.each{|e|e.erase! if e.class==Sketchup::Face}
    gedge.find_faces
    face=nil
    gents.each{|e|face=e if e.class==Sketchup::Face}
    return false if not face
    face.pushpull(1.0)
    edges=[]
    gents.each{|e|edges<<e if e.class==Sketchup::Edge}
    edges.each{|e|
      if e.smooth? and e.soft?
        group.erase! if group.valid?
        return false ### a circle
      end#if
    }
    group.erase! if group.valid?
    return true ### a polygon
end#def

class Geom::Point3d
	def is_between_points?(pt1,pt2)
		d1=(self.distance(pt1)+self.distance(pt2))
		d2=pt1.distance(pt2)+0
		if (d1<=d2) or (d1-d2<1e-10)
	      return true #if self != pt1 and self != pt2
		end
		return false
    end#def
end #class Geom::Point3d

end#class


#-----------------------------------------------------------------------------
# shortcut
def adjusttool2D
    Sketchup.active_model.select_tool AdjustTool2D.new
end
######-----------------------------------------------
